import numpy as np
import math
import cv2
import random

def centers(N, c, p, x, u, v_old):
    for i in range(c):
        for j in range(p):
            s1 = 0
            s2 = 0
            for k in range(N):
                s1 += u[k, i] * x[k, j]
                s2 += u[k, i]
            if s2 == 0:
                v[i, j] = v_old[i, j]
            else:
                v[i, j] = s1 / s2
    return v


def distances(N, c, p, x, v):
    D = np.zeros((N, c))
    for k in range(N):
        for i in range(c):
            s = 0;
            for j in range(p):
                s = s + pow((x[k, j] - v[i, j]), 2)
            D[k, i] = math.sqrt(s)
    return D


def membership(N, c, D):
    u = np.zeros((N, c))
    for k in range(N):
        id = np.argmin(D[k, :])
        u[k, id] = 1
    return u


A = cv2.imread('Bird.jpg')
N_i = len(A)
N_j = len(A[0])



x = np.zeros((N_i * N_j, 3))

k = 0
for i in range(N_i):
    for j in range(N_j):
        for l in range(3):
            x[k, l] = A[i, j, l]
        k = k + 1



N = len(x);
p = len(x[0]);
c = 8


v = np.zeros((c, p))

x_min = x.min(axis=0)
x_max = x.max(axis=0)

for i in range(c):
    for j in range(p):
        v[i, j] = x_min[j] + random.random() * (x_max[j] - x_min[j])


epsilon = 1
iteration = 0
while epsilon > 0.0001:
    iteration = iteration + 1
    v_old = v
    D = distances(N, c, p, x, v)
    u = membership(N, c, D)
    v = centers(N, c, p, x, u, v_old)

    dist = np.zeros(c)
    for i in range(c):
        s = 0
        for j in range(p):
            s = s + pow(v[i, j] - v_old[i, j], 2)

        dist[i] = math.sqrt(s)
    epsilon = max(dist)


B = np.zeros((N_i, N_j, 3))

k = 0
for ni in range(N_i):
    for nj in range(N_j):
        for i in range(c):
            if u[k, i] == 1:
                id = i
        k = k + 1
        for l in range(3):
            B[ni, nj, l] = v[id, l]

B = B.astype(np.uint8)

cv2.imshow("image1", A)
cv2.imshow("image2", B)
cv2.waitKey()